<template>
  <div class="app-container">
    <el-form :model="queryParams" ref="queryRef" :inline="true" v-show="showSearch" label-width="68px">
      <el-form-item label="大屏名称" prop="screenName">
        <el-input v-model="queryParams.screenName" placeholder="请输入大屏名称" clearable @keyup.enter="handleQuery" />
      </el-form-item>
      <el-form-item label="标识" prop="code">
        <el-input v-model="queryParams.code" placeholder="请输入标识" clearable @keyup.enter="handleQuery" />
      </el-form-item>
      <el-form-item label="启用状态" prop="status">
        <el-select v-model="queryParams.status" placeholder="请选择启用状态" clearable style="width: 150px;">
          <el-option v-for="dict in sys_normal_disable" :key="dict.value" :label="dict.label" :value="dict.value" />
        </el-select>
      </el-form-item>
      <el-form-item>
        <el-button type="primary" icon="Search" @click="handleQuery">搜索</el-button>
        <el-button icon="Refresh" @click="resetQuery">重置</el-button>
      </el-form-item>
    </el-form>

    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button type="primary" plain icon="Plus" @click="handleAdd"
          v-hasPermi="['hnyz:screenSettings:add']">新增</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button type="success" plain icon="Edit" :disabled="single" @click="handleUpdate"
          v-hasPermi="['hnyz:screenSettings:edit']">修改</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button type="danger" plain icon="Delete" :disabled="multiple" @click="handleDelete"
          v-hasPermi="['hnyz:screenSettings:remove']">删除</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button type="warning" plain icon="Download" @click="handleExport"
          v-hasPermi="['hnyz:screenSettings:export']">导出</el-button>
      </el-col>
      <right-toolbar v-model:showSearch="showSearch" @queryTable="getList"></right-toolbar>
    </el-row>

    <el-table v-loading="loading" :data="screenSettingsList" @selection-change="handleSelectionChange">
      <el-table-column type="selection" width="55" align="center" />
      <el-table-column label="自增主键" align="center" prop="id" />
      <el-table-column label="大屏名称" align="center" prop="screenName" />
      <el-table-column label="标识" align="center" prop="code" />
      <el-table-column label="模版页名称" align="center" prop="pageName" />
      <el-table-column label="启用状态" align="center" prop="status">
        <template #default="scope">
          <dict-tag :options="sys_normal_disable" :value="scope.row.status" />
        </template>
      </el-table-column>
      <el-table-column label="备注" align="center" prop="remark" />
      <el-table-column label="操作" align="center" class-name="small-padding fixed-width">
        <template #default="scope">
          <el-button link type="primary" icon="Edit" @click="handleUpdate(scope.row)"
            v-hasPermi="['hnyz:screenSettings:edit']">修改</el-button>
          <el-button link type="primary" icon="Delete" @click="handleDelete(scope.row)"
            v-hasPermi="['hnyz:screenSettings:remove']">删除</el-button>
        </template>
      </el-table-column>
    </el-table>

    <pagination v-show="total > 0" :total="total" v-model:page="queryParams.pageNum" v-model:limit="queryParams.pageSize"
      @pagination="getList" />

    <!-- 添加或修改大屏设置管理对话框 -->
    <el-dialog :title="title" v-model="open" width="500px" append-to-body>
      <el-form ref="screenSettingsRef" :model="form" :rules="rules" label-width="80px">
        <el-form-item label="大屏名称" prop="screenName">
          <el-input v-model="form.screenName" placeholder="请输入大屏名称" />
        </el-form-item>
        <el-form-item label="标识" prop="code">
          <el-input v-model="form.code" placeholder="请输入标识" />
        </el-form-item>
        <el-form-item label="模版页" prop="pageId">
          <el-select v-model="form.pageId" placeholder="请选择模版页">
            <el-option v-for="dict in pageOptions" :key="dict.pageId" :label="dict.pageName"
              :value="dict.pageId"></el-option>
          </el-select>
        </el-form-item>
        <el-form-item label="启用状态" prop="status">
          <el-radio-group v-model="form.status">
            <el-radio v-for="dict in sys_normal_disable" :key="dict.value" :label="dict.value">{{ dict.label }}</el-radio>
          </el-radio-group>
        </el-form-item>
        <el-form-item label="备注" prop="remark">
          <el-input v-model="form.remark" placeholder="请输入备注" />
        </el-form-item>
      </el-form>
      <template #footer>
        <div class="dialog-footer">
          <el-button type="primary" @click="submitForm">确 定</el-button>
          <el-button @click="cancel">取 消</el-button>
        </div>
      </template>
    </el-dialog>
  </div>
</template>

<script setup name="ScreenSettings">
import { listScreenSettingsForm, getScreenSettings, delScreenSettings, addScreenSettings, updateScreenSettings } from "@/api/hnyz/screenSettings";
import {getTemplatePageList} from "@/api/hnyz/templatePage";
import { onMounted ,ref} from "vue";

onMounted(() => {
  getPageOptions();
});

const pageOptions = ref([]);
// 获取模版页选项
function getPageOptions() {
  getTemplatePageList().then(response => {
    pageOptions.value = response.data;
  });
}
const { proxy } = getCurrentInstance();
const { sys_normal_disable } = proxy.useDict('sys_normal_disable');

const screenSettingsList = ref([]);
const open = ref(false);
const loading = ref(true);
const showSearch = ref(true);
const ids = ref([]);
const single = ref(true);
const multiple = ref(true);
const total = ref(0);
const title = ref("");

const data = reactive({
  form: {},
  queryParams: {
    pageNum: 1,
    pageSize: 10,
    screenName: null,
    code: null,
    status: null,
    pageId: null,
  },
  rules: {
    screenName: [
      { required: true, message: "大屏名称不能为空", trigger: "blur" }
    ],
    code: [
      { required: true, message: "标识不能为空", trigger: "blur" }
    ],
    pageId: [
      { required: true, message: "模版页id不能为空", trigger: "change" }
    ],
  }
});

const { queryParams, form, rules } = toRefs(data);

/** 查询大屏设置管理列表 */
function getList() {
  loading.value = true;
  listScreenSettingsForm(queryParams.value).then(response => {
    screenSettingsList.value = response.rows;
    total.value = response.total;
    loading.value = false;
  });
}

// 取消按钮
function cancel() {
  open.value = false;
  reset();
}

// 表单重置
function reset() {
  form.value = {
    id: null,
    screenName: null,
    code: null,
    pageId: null,
    status: null,
    createBy: null,
    createTime: null,
    updateBy: null,
    updateTime: null,
    remark: null
  };
  proxy.resetForm("screenSettingsRef");
}

/** 搜索按钮操作 */
function handleQuery() {
  queryParams.value.pageNum = 1;
  getList();
}

/** 重置按钮操作 */
function resetQuery() {
  proxy.resetForm("queryRef");
  handleQuery();
}

// 多选框选中数据
function handleSelectionChange(selection) {
  ids.value = selection.map(item => item.id);
  single.value = selection.length != 1;
  multiple.value = !selection.length;
}

/** 新增按钮操作 */
function handleAdd() {
  reset();
  open.value = true;
  title.value = "添加大屏设置管理";
}

/** 修改按钮操作 */
function handleUpdate(row) {
  reset();
  const _id = row.id || ids.value
  getScreenSettings(_id).then(response => {
    form.value = response.data;
    open.value = true;
    title.value = "修改大屏设置管理";
  });
}

/** 提交按钮 */
function submitForm() {
  proxy.$refs["screenSettingsRef"].validate(valid => {
    if (valid) {
      if (form.value.id != null) {
        updateScreenSettings(form.value).then(response => {
          proxy.$modal.msgSuccess("修改成功");
          open.value = false;
          getList();
        });
      } else {
        addScreenSettings(form.value).then(response => {
          proxy.$modal.msgSuccess("新增成功");
          open.value = false;
          getList();
        });
      }
    }
  });
}

/** 删除按钮操作 */
function handleDelete(row) {
  const _ids = row.id || ids.value;
  proxy.$modal.confirm('是否确认删除大屏设置管理编号为"' + _ids + '"的数据项？').then(function () {
    return delScreenSettings(_ids);
  }).then(() => {
    getList();
    proxy.$modal.msgSuccess("删除成功");
  }).catch(() => { });
}

/** 导出按钮操作 */
function handleExport() {
  proxy.download('hnyz/screenSettings/export', {
    ...queryParams.value
  }, `screenSettings_${new Date().getTime()}.xlsx`)
}

getList();
</script>
